--[[-------------------------------------------------------------------------
  Base code from oUF_Lily, original edit by Haleth: kamii ninjaed this!
    Please ask for permission before redistributing this work.
---------------------------------------------------------------------------]]

local dummy = function() end

local parent, ns = ...
local oUF = ns.oUF

local reactioncolors = {
	[1] = {226/255, 45/255, 75/255},
	[2] = {226/255, 45/255, 75/255},
	[3] = {226/255, 115/255, 75/255},
	[4] = {255/255, 255/255, 34/255},
	[5] = {143/255, 194/255, 32/255},
	[6] = {51/255, 204/255, 38/255},
	[7] = {51/255, 255/255, 38/255},
	[8] = {51/255, 255/255, 38/255},
}

local class = select(2, UnitClass("player"))

local colors = setmetatable({
	power = setmetatable({
		["MANA"] = {247/255, 221/255, 228/255},
		["RAGE"] = {247/255, 221/255, 228/255},
		["FUEL"] = {247/255, 221/255, 228/255},
		["FOCUS"] = {247/255, 221/255, 228/255},
		["ENERGY"] = {247/255, 221/255, 228/255},
		["AMMOSLOT"] = {247/255, 221/255, 228/255},
		["RUNIC_POWER"] = {247/255, 221/255, 228/255},
		["POWER_TYPE_STEAM"] = {247/255, 221/255, 228/255},
		["POWER_TYPE_PYRITE"] = {247/255, 221/255, 228/255},
	}, {__index = oUF.colors.power}),
}, {__index = oUF.colors})

--[[ Dropdown menu ]]
local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("^%l", string.upper)

	if(cunit == 'Vehicle') then
		cunit = 'Pet'
	end

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

--[[ Short values ]]

local siValue = function(val)
	if(val >= 1e6) then
		return format("%.2fm", val * 0.000001)
	elseif(val >= 1e4) then
		return format("%.1fk", val * 0.001) 
	else
		return val
	end
end

--[[ Tags ]]

oUF.Tags['kamiihealth'] = function(unit)
	--[[if(not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit)) then return end]]--
	if(not UnitIsConnected(unit)) then
		return('D/C')
	elseif(UnitIsDead(unit)) then
		return('Dead')
	elseif(UnitIsGhost(unit)) then
		return('Ghost')
	else
	local min, max = UnitHealth(unit), UnitHealthMax(unit)
		if(unit=="player" or unit=="target") then
			if ((min/max*100) < 100) then
			return format('|cffffffff%s (%d%%)|r', siValue(min),(min/max*100)) 
			else
			return format('|cffffffff%s|r', siValue(min)) 
			end
		else
		return format('|cffffffff%s|r', siValue(min)) 
		end
	end
end
oUF.TagEvents['kamiihealth'] = oUF.TagEvents.missinghp

oUF.Tags['kamiipower'] = function(unit)
	local min, max = UnitPower(unit), UnitPowerMax(unit)
	if(min == 0 or max == 0 or not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit)) then return end

	return siValue(min)
end
oUF.TagEvents['kamiipower'] = oUF.TagEvents.missingpp

--[[ Update health bar colour ]]

local UpdateHealth = function(self, event, unit)
	if(self.unit == unit) then
		local r, g, b, t
		if(UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) or not UnitIsConnected(unit)) then
			r, g, b = .6, .6, .6
		elseif(unit == 'pet') then
			t = self.colors.happiness[GetPetHappiness()] or reactioncolors[UnitReaction(unit, "player")]
		elseif(UnitIsPlayer(unit)) then
			local _, class = UnitClass(unit)
			t = self.colors.class[class]
		else
			t = reactioncolors[UnitReaction(unit, "player")]
		end

		if(t) then
			r, g, b = t[1], t[2], t[3]
		end

		if(r) then
			self.Health:SetStatusBarColor(r, g, b)
		end

			if self.Text then self.Text:SetTextColor(1, 1, 1) end
	end
end

--[[ Update health ]]

local PostUpdateHealth = function(Health, unit, min, max)
	if(UnitIsDead(unit)) then
		Health:SetValue(0)
	elseif(UnitIsGhost(unit)) then
		Health:SetValue(0)
	end

	if(Health.value) then
		if(unit=="target") then
			Health.value:SetTextColor(unpack(reactioncolors[UnitReaction("player", unit) or 5]))
		end
	end

	return UpdateHealth(Health:GetParent(), 'PostUpdateHealth', unit)
end

_G["BuffFrame"]:Hide()

--[[ Aura icon filter ]]

local PostUpdateIcon
do
	local playerUnits = {
		player = true,
		pet = true,
		vehicle = true,
	}

	PostUpdateIcon = function(icons, unit, icon, index, offset, filter, isDebuff)
		local texture = icon.icon
		local name, _, _, _, dtype, duration, expirationTime, unitCaster = UnitAura(unit, index, icon.filter)
		if(unit~="target") then icon:Show() end
		if(UnitIsFriend("player", unit) or playerUnits[icon.owner]  or not icon.debuff or UnitIsPlayer(unit)) then
			icon:Show()
		else
			icon:Hide()
		end
	end
end

--[[ Update power value ]]

local PostUpdatePower = function(Power, unit, min, max)
	local Health = Power:GetParent().Health
	if(min == 0 or max == 0 or not UnitIsConnected(unit)) then
		Power:SetValue(0)
	elseif(UnitIsDead(unit) or UnitIsGhost(unit)) then
		Power:SetValue(0)
	end
end

local RAID_TARGET_UPDATE = function(self, event)
	local index = GetRaidTargetIndex(self.unit)
	if(index) then
		self.RIcon:SetText(ICON_LIST[index].."22|t")
	else
		self.RIcon:SetText()
	end
end

--[[ Temp buffs ]]

for i = 1, 3 do
	_G["TempEnchant"..i.."Border"]:Hide()
	bu = _G["TempEnchant"..i]
	ic = _G["TempEnchant"..i.."Icon"]
	du = _G["TempEnchant"..i.."Duration"]

	bu:ClearAllPoints()
	bu:SetHeight(30)
	bu:SetWidth(30)

	if i==1 then
		bu:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -6, 50)
	elseif i==2 then
		bu:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -6, 88)
	else
		bu:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -6, 126)
	end

	bu:SetBackdrop({
		edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", 
		edgeSize = 1, 
	})
	bu:SetBackdropBorderColor(0, 0, 0)

	ic:SetTexCoord(.08, .92, .08, .92)
	du:ClearAllPoints()
	du:SetPoint("BOTTOM", bu, 0, -2)
	du:SetFont(PIXELFONTV, 10, "OUTLINEMONOCHROME")
	du:SetDrawLayer("OVERLAY")
	du:SetTextColor(1, 1, 1)
	du.SetTextColor = dummy
	du:SetShadowColor(0, 0, 0, 0)
end

--[[ Global ]]

local Shared = function(self, unit, isSingle)
	self.menu = menu

	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)

	-- XXX: Change to AnyUp when RegisterAttributeDriver doesn't cause clicks
	-- to get incorrectly eaten.
	self:RegisterForClicks"AnyDown"

	self.bg = CreateFrame("Frame", nil, self)
	self.bg:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeSize = 1,
	})
	self.bg:SetBackdropColor(0, 0, 0, .4)
	self.bg:SetBackdropBorderColor(0, 0, 0)
	self.bg:SetPoint("TOPLEFT", self, -1, 1)
	self.bg:SetPoint("BOTTOMRIGHT", self, 1, -1)
	self.bg:SetFrameStrata("BACKGROUND")

	--[[ Health ]]

	local Health = CreateFrame("StatusBar", nil, self)
	Health:SetStatusBarTexture(HAL_K)
	Health:SetFrameStrata("LOW")

	Health.frequentUpdates = true
	Health.Smooth = true

	Health:SetPoint("TOP")
	Health:SetPoint("LEFT")
	Health:SetPoint("RIGHT")
	Health:SetPoint("BOTTOM", 0, 2)

	self.Health = Health

	--[[ Power ]]

	local Power = CreateFrame("StatusBar", nil, self)
	Power:SetStatusBarTexture(HAL_K)

	Power.colorPower = true 
	Power.frequentUpdates = true
	Power.Smooth = true

	Power:SetHeight(1)

	Power:SetPoint("LEFT")
	Power:SetPoint("RIGHT")
	Power:SetPoint("TOP", Health, "BOTTOM", 0, -1)
	self.Power = Power

	local Powerbg = CreateFrame("Frame", nil, self)
	Powerbg:SetBackdrop({
		bgFile = "",
		edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeSize = 1,
	})
	Powerbg:SetBackdropColor(0, 0, 0, 0)
	Powerbg:SetBackdropBorderColor(0, 0, 0)
	Powerbg:SetPoint("TOPLEFT", self.Power, -1, 1)
	Powerbg:SetPoint("BOTTOMRIGHT", self.Power, 1, -1)
	Powerbg:SetFrameStrata("BACKGROUND")
	self.Powerbg = Powerbg

	--[[ Castbar code is modified from tukUI ]]

	local Castbar = CreateFrame("StatusBar", nil, self)
		if (unit=="player" or unit=="target") then
	Castbar:SetStatusBarTexture(HAL_A)
	Castbar:SetStatusBarColor(1,1,1) 

	Castbar:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		tile = true, tileSize = 16,
		insets = {top = -1, left = -1, bottom = -1, right = -1}
		})
	Castbar:SetBackdropColor(0, 0, 0)
	Castbar:SetFrameStrata("LOW")
	end
		
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetTexture"Interface\\CastingBar\\UI-CastingBar-Spark"
	Spark:SetBlendMode"ADD"
	Spark:SetWidth(10)
	Castbar.Spark = Spark
	self.Castbar = Castbar


	local PostCastStart = function(Castbar, unit, spell, spellrank)
		if Castbar.Text then Castbar.Text:SetText(spell) end

		if self.Iconbg then
			if Castbar.interrupt then
				self.Iconbg:SetBackdropBorderColor(1, 0, 0)
			else
				self.Iconbg:SetBackdropBorderColor(0, 0, 0)
			end
		end
	end

	local PostCastStop = function(Castbar, unit)
		if Castbar.Text then Castbar.Text:SetText("") end
	end

	local PostCastStopUpdate = function(self, event, unit)
		if(unit ~= self.unit) then return end
		return PostCastStop(self.Castbar, unit)
	end

	--[[ Set up the layout ]]

	self.colors = colors

	self.disallowVehicleSwap = true

	if(isSingle) then
		if(unit=="player" or unit=="target") then
			self:SetSize(202, 20)
		elseif(unit=="pet" or unit=="focus") then
			self:SetSize(75, 15)
		end
	end

	self:RegisterEvent("UNIT_NAME_UPDATE", PostCastStopUpdate)
	table.insert(self.__elements, PostCastStopUpdate)

	Castbar.PostChannelStart = PostCastStart
	Castbar.PostCastStart = PostCastStart

	Castbar.PostCastStop = PostCastStop
	Castbar.PostChannelStop = PostCastStop

	Health.PostUpdate = PostUpdateHealth
	Power.PostUpdate = PostUpdatePower
end

-- [[ Unit specific functions ]]

local UnitSpecific = {
	pet = function(self, ...)
		Shared(self, ...)

		local Health = self.Health
		local Power = self.Power
		local Powerbg = self.Powerbg

		Health:SetHeight(13)
		Power:Hide()
		Powerbg:Hide()		

		self:RegisterEvent("UNIT_HAPPINESS", UpdateHealth)
	end,

	player = function(self, ...)
		Shared(self, ...)

		local Health = self.Health
		local Power = self.Power
		local Castbar = self.Castbar
		local Spark = Castbar.Spark

		Health:SetHeight(19)

		local HealthPoints = CreatePFS(Health, 10)

		HealthPoints:SetPoint('RIGHT', self.Health, -2, 0)

		self:Tag(HealthPoints, '[kamiihealth]')
		Health.value = HealthPoints

		local PowerPoints = CreatePFS(Power, 10)
		local _, UnitPowerType = UnitPowerType("player")
		PowerPoints:SetPoint('LEFT', self.Health, 2,0)
		PowerPoints:SetJustifyH("LEFT")

		self:Tag(PowerPoints, '[kamiipower]')

		Power.value = PowerPoints

		if class == "PALADIN" or class == "WARLOCK" then
			local UpdateHoly = function(self, event, unit, powerType)
				if(self.unit ~= unit or (powerType and powerType ~= 'HOLY_POWER')) then return end
				local num = UnitPower(unit, SPELL_POWER_HOLY_POWER)
				for i = 1, MAX_HOLY_POWER do
					if(i <= num) then
						self.glow:SetAlpha(1)
						CreatePulse(self.glow)
						self.count:SetText(num)
						self.count:SetTextColor(1, 1, 0)
						self.count:SetFont(PIXELFONTV, 40, "OUTLINEMONOCHROME")
					elseif num == 0 then
						self.glow:SetScript("OnUpdate", nil)
						self.glow:SetAlpha(0)
						self.count:SetText("")
					else
						self.glow:SetScript("OnUpdate", nil)
						self.glow:SetAlpha(0)
						self.count:SetText(num)
						self.count:SetTextColor(1, 1, 1)
						self.count:SetFont(PIXELFONTV, 20, "OUTLINEMONOCHROME")
					end
				end
			end

			local UpdateShards = function(self, event, unit, powerType)
				if(self.unit ~= unit or (powerType and powerType ~= 'SOUL_SHARDS')) then return end
				local num = UnitPower(unit, SPELL_POWER_SOUL_SHARDS)
				for i = 1, SHARD_BAR_NUM_SHARDS do
					if(i <= num) then
						self.glow:SetScript("OnUpdate", nil)
						self.glow:SetAlpha(0)
						self.count:SetText("")
					elseif num == 0 then
						self.glow:SetAlpha(1)
						CreatePulse(self.glow)
						self.count:SetText("0")
						self.count:SetTextColor(0.6 * 1.3, 0.47 * 1.3, 0.85 * 1.3)
						self.count:SetFont(PIXELFONTV, 40, "OUTLINEMONOCHROME")
					else
						self.glow:SetScript("OnUpdate", nil)
						self.glow:SetAlpha(0)
						self.count:SetText(num)
						self.count:SetTextColor(1, 1, 1)
						self.count:SetFont(PIXELFONTV, 20, "OUTLINEMONOCHROME")
					end
				end
			end

			local glow = CreateFrame("Frame", nil, self)
			glow:SetBackdrop({
				edgeFile = "Interface\\AddOns\\!!media\\glowTex",
				edgeSize = 5,
			})
			glow:SetPoint("TOPLEFT", self, -6, 6)
			glow:SetPoint("BOTTOMRIGHT", self, 6, -6)

			if class == "PALADIN" then
				glow:SetBackdropBorderColor(228/255,225/255,16/255)
			else
				glow:SetBackdropBorderColor(255/255,101/255,101/255)
			end

			self.glow = glow

			local count = CreatePFS(self, 20)
			count:SetPoint("LEFT", self, "RIGHT", 10, 0)

			self.count = count

			if class == "WARLOCK" then
				self.SoulShards = glow
				glow.Override = UpdateShards
			elseif class == "PALADIN" then
				self.HolyPower = glow
				glow.Override = UpdateHoly
			end
		end

    Castbar:SetPoint('CENTER', oUF_KamiiPlayer, 'CENTER', 0, -18) 
    Castbar:SetParent(UIParent)
    Castbar:SetWidth(202) 
    Castbar:SetHeight(6) 
		
		Castbar.SafeZone = Castbar:CreateTexture(nil, "BORDER")
		Castbar.SafeZone:SetTexture(HAL_A)
		Castbar.SafeZone:SetVertexColor(0.5, 0.5, 0.5, 0.7)

		Spark:SetHeight(self.Castbar:GetHeight())

		Castbar.Text = CreatePFS(Health, 10)
		Castbar.Text:SetPoint('LEFT', Castbar, 1, -8)
		
		Castbar.Time = CreatePFS(Castbar, 10)
    Castbar.Time:SetTextColor(1,1,1)
    Castbar.Time:SetJustifyH("RIGHT")
		Castbar.Time:SetPoint('RIGHT', Castbar, -1, -8)

		local IconFrame = CreateFrame("Frame", nil, Castbar)
		IconFrame:SetPoint("RIGHT", self, "LEFT", -5, -6)
		IconFrame:SetHeight(31)
		IconFrame:SetWidth(31)

		local Icon = IconFrame:CreateTexture(nil, "BACKGROUND")
		Icon:SetAllPoints(IconFrame)
		Icon:SetTexCoord(.08, .92, .08, .92)

		Castbar.Icon = Icon

		self.Iconbg = CreateFrame("Frame", nil, IconFrame)
			self.Iconbg:SetBackdrop({
			bgFile = "",
			edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", 
			edgeSize = 1, 
			insets = {left = 0, right = 0, top = 0, bottom = 0}
		})
		self.Iconbg:SetPoint("TOPLEFT", IconFrame, "TOPLEFT", -1 , 1)
		self.Iconbg:SetPoint("BOTTOMRIGHT", IconFrame, "BOTTOMRIGHT", 1, -1)
		self.Iconbg:SetFrameStrata("LOW")

		local Buffs = CreateFrame("Frame", nil, self)
		Buffs.initialAnchor = "TOPRIGHT"

		Buffs:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -183, -40)

		local RaidIcon = CreatePFS(Health, 10)
		RaidIcon:SetPoint("RIGHT", self, "LEFT", -3, 0)

		self.RIcon = RaidIcon
		self:RegisterEvent("RAID_TARGET_UPDATE", RAID_TARGET_UPDATE)
		table.insert(self.__elements, RAID_TARGET_UPDATE)

		Buffs["growth-y"] = "DOWN"
		Buffs["growth-x"] = "LEFT"
		Buffs["spacing-x"] = 3
		Buffs["spacing-y"] = 3

		Buffs:SetHeight(100)
		Buffs:SetWidth(475)
		Buffs.num = 51
		Buffs.size = 25

		self.Buffs = Buffs

		local Debuffs = CreateFrame("Frame", nil, self)
		Debuffs.initialAnchor = "TOPRIGHT"
		Debuffs:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -183, -127)
		Debuffs["growth-x"] = "LEFT"
		Debuffs["growth-y"] = "DOWN"
		Debuffs['spacing-x'] = 3
		Debuffs['spacing-y'] = 3

		Debuffs:SetHeight(100)
		Debuffs:SetWidth(475)
		Debuffs.num = 51
		Debuffs.size = 25

		self.Debuffs = Debuffs

		Debuffs.PostUpdateIcon = PostUpdateIcon

		Buffs.PostUpdateIcon = PostUpdateIcon
	end,

	target = function(self, ...)
		Shared(self, ...)

		local Health = self.Health
		local Power = self.Power
		local Castbar = self.Castbar
		local Spark = Castbar.Spark

		Health:SetHeight(19)

		local HealthPoints = CreatePFS(Health,10)

		HealthPoints:SetPoint('RIGHT', self.Health, -2,0)
		self:Tag(HealthPoints, '[kamiihealth]')
		Health.value = HealthPoints

		Castbar:SetPoint('CENTER', oUF_KamiiTarget, 'CENTER', 0, -21) 
		Castbar:SetWidth(202) 
    Castbar:SetHeight(12) 

		Spark:SetHeight(self.Castbar:GetHeight())

		Castbar.Text = CreatePFS(Health, 10)
		Castbar.Text:SetPoint('LEFT', Castbar, "LEFT", 2, 0)
		
		Castbar.Time = CreatePFS(Castbar, 10)
    Castbar.Time:SetTextColor(1,1,1)
    Castbar.Time:SetJustifyH("CENTER")
		Castbar.Time:SetPoint('RIGHT', Castbar, 'RIGHT', -2,0)

		local IconFrame = CreateFrame("Frame", nil, Castbar)
		IconFrame:SetPoint("RIGHT", self, "LEFT", -5, -9)
		IconFrame:SetHeight(37)
		IconFrame:SetWidth(37)
		IconFrame:SetFrameStrata("BACKGROUND")

		local Icon = IconFrame:CreateTexture(nil, "BACKGROUND")
		Icon:SetAllPoints(IconFrame)
		Icon:SetTexCoord(.08, .92, .08, .92)

		Castbar.Icon = Icon

		self.Iconbg = CreateFrame("Frame", nil, IconFrame)
		self.Iconbg:SetBackdrop({
			bgFile = "",
			edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", 
			edgeSize = 1, 
			insets = {left = 0, right = 0, top = 0, bottom = 0}
		})
		self.Iconbg:SetPoint("TOPLEFT", IconFrame, "TOPLEFT", -1 , 1)
		self.Iconbg:SetPoint("BOTTOMRIGHT", IconFrame, "BOTTOMRIGHT", 1, -1)
		self.Iconbg:SetFrameStrata("LOW")

		local Name = CreatePFS(Health, 10)
		Name:SetPoint('LEFT', self.Health, 2, 0)
		Name:SetPoint('RIGHT', Health.value, 'LEFT')
		Name:SetJustifyH("LEFT")
		Name:SetTextColor(1, 1, 1)
		self:Tag(Name, '[name]')
		self.Name = Name

		local RaidIcon = CreatePFS(Health, 10)
		RaidIcon:SetPoint("RIGHT", self, "LEFT", -3, 0)

		self.RIcon = RaidIcon
		self:RegisterEvent("RAID_TARGET_UPDATE", RAID_TARGET_UPDATE)
		table.insert(self.__elements, RAID_TARGET_UPDATE)

		local Buffs = CreateFrame("Frame", nil, self)
		Buffs.initialAnchor = "BOTTOM"
		Buffs:SetPoint('BOTTOM', self, 'BOTTOM', -92, 62)
		Buffs["growth-y"] = "DOWN"
		Buffs["growth-x"] = "RIGHT"
		Buffs["spacing-x"] = 3
		Buffs["spacing-y"] = 3
		Buffs:SetHeight(40)
		Buffs:SetWidth(210)
		Buffs.num = 10
		Buffs.size = 17

		self.Buffs = Buffs

		local Debuffs = CreateFrame("Frame", nil, self)
		Debuffs.initialAnchor = "BOTTOM"
		Debuffs:SetPoint('BOTTOM', self, 'BOTTOM', -87, 31)
		Debuffs["growth-x"] = "RIGHT"
		Debuffs["growth-y"] = "DOWN"
		Debuffs['spacing-x'] = 3
		Debuffs['spacing-y'] = 3
		Debuffs:SetHeight(40)
		Debuffs:SetWidth(210)
		Debuffs.num = 6
		Debuffs.size = 28

		self.Debuffs = Debuffs

		Debuffs.PostUpdateIcon = PostUpdateIcon
		Buffs.PostUpdateIcon = PostUpdateIcon

	end,

	focus = function(self, ...)
		Shared(self, ...)

		local Health = self.Health
		local Castbar = self.Castbar
		local Spark = Castbar.Spark

		Health:SetHeight(13)	

		Castbar:SetAllPoints(Health)
		Castbar:SetStatusBarTexture("")
		Castbar.Width = self:GetWidth()
		Spark:SetHeight(Health:GetHeight())

	end,
}

do
	UnitSpecific.boss = function(self)
		if unit and unit:find("boss%d") then
			Shared(self)

			self:SetAttribute("type2", "focus")

			local Health, Power = self.Health, self.Power

			self:SetAttribute('initial-height', 12)
			self:SetAttribute('initial-width', 126)

			Health:SetHeight(10)

			local RaidIcon = CreatePFS(Health, 10)
			RaidIcon:SetPoint("CENTER")

			self.RIcon = RaidIcon
			self:RegisterEvent("RAID_TARGET_UPDATE", RAID_TARGET_UPDATE)
			table.insert(self.__elements, RAID_TARGET_UPDATE)
		end
	end
end

do
	local range = {
		insideAlpha = 1,
		outsideAlpha = .5,
	}

	UnitSpecific.party = function(self, ...)
		Shared(self, ...)

		self.disallowVehicleSwap = false

		local Health, Power, Powerbg = self.Health, self.Power, self.Powerbg
		Health:SetPoint("TOP")
		Health:SetPoint("LEFT")
		Health:SetPoint("RIGHT")
		Health:SetPoint("BOTTOM")
		self:SetSize(30, 15)
		Health:SetHeight(15)
		Power:Hide()
		Powerbg:Hide()		

		local RaidIcon = CreatePFS(Health, 10)
		RaidIcon:SetPoint("CENTER")

		self.RIcon = RaidIcon
		self:RegisterEvent("RAID_TARGET_UPDATE", RAID_TARGET_UPDATE)
		table.insert(self.__elements, RAID_TARGET_UPDATE)

		local Leader = CreatePFS(self, 10, "LEFT")
		Leader:SetText("!")
		Leader:SetPoint("LEFT", Health, 2, 0)

		self.Leader = Leader

		local MasterLooter = CreatePFS(self, 10, "RIGHT")
		MasterLooter:SetText("m")
		MasterLooter:SetPoint("RIGHT", Health, -2, 0)

		self.MasterLooter = MasterLooter

		local rc = Health:CreateTexture(nil, "OVERLAY")
		rc:SetPoint"TOPLEFT"
		rc:SetHeight(16)
		rc:SetWidth(16)
		self.ReadyCheck = rc

		local dbh = Health:CreateTexture(nil, "OVERLAY")
		dbh:SetTexture(QUEST_BORDER1)
		dbh:SetVertexColor(0, 0, 0, 1)
		dbh.DebuffHighlightAlpha = 1
		dbh.DebuffHighlightFilter = true
		dbh:SetBlendMode("ADD")
		dbh:SetPoint("TOPLEFT", self, -3, 3)
		dbh:SetPoint("BOTTOMRIGHT", self, 3, -3)
		self.DebuffHighlight = dbh

		
		local Threat = CreatePFS(Health, 10)
		Threat:SetText("x")
		Threat:SetPoint("TOP", self, "TOP", 0, 0)
		self.Threat = Threat

		self.Range = range
	end
end

--[[ Register and activate style ]]

oUF:RegisterStyle("Kamii", Shared)
for unit,layout in next, UnitSpecific do
	oUF:RegisterStyle('Kamii - ' .. unit:gsub("^%l", string.upper), layout)
end

local spawnHelper = function(self, unit, ...)
	if(UnitSpecific[unit]) then
		self:SetActiveStyle('Kamii - ' .. unit:gsub("^%l", string.upper))
		local object = self:Spawn(unit)
		object:SetPoint(...)
		return object
	else
		self:SetActiveStyle'Kamii'
		local object = self:Spawn(unit)
		object:SetPoint(...)
		return object
	end
end

oUF:Factory(function(self)
	self:Spawn"focus":SetPoint('CENTER',UIParent,'CENTER', 143, -225)
	self:Spawn"pet":SetPoint('CENTER',UIParent,'CENTER', 143, -277)
	self:Spawn"player":SetPoint('CENTER',UIParent,'CENTER', 0, -279)
	self:Spawn"target":SetPoint('CENTER',UIParent,'CENTER', 0, -225)
	spawnHelper(self, 'focus', 'CENTER',UIParent,'CENTER', 143, -225)
	spawnHelper(self, 'pet', 'CENTER',UIParent,'CENTER', 143, -277)
	spawnHelper(self, 'player', 'CENTER',UIParent,'CENTER', 0, -279)
	spawnHelper(self, 'target', 'CENTER',UIParent,'CENTER', 0, -225)

	self:SetActiveStyle'Kamii - Party'

	local party = self:SpawnHeader(
		nil, nil, 'party,solo', 
		'showParty', false, 
		'showPlayer', true,
		'showSolo', false, 
		'yoffset', -3, 
		'maxColumns', 5, 
		'unitsperColumn', 1, 
		'columnSpacing', 3, 
		'columnAnchorPoint', "RIGHT"
	)

		party:SetPoint("CENTER", 280, -70)

	local raid = self:SpawnHeader(nil, nil, 'raid,party,solo',
		'showPlayer', true,
		'showSolo', false,
		'showParty', true,
		'showRaid', true,
		'xoffset', 5,
		'yOffset', -4,
		'point', "TOP",
		'groupFilter', '1,2,3,4,5,6,7,8',
		'groupingOrder', '1,2,3,4,5,6,7,8',
		'groupBy', 'GROUP',
		'maxColumns', 7,
		'unitsPerColumn', 5,
		'columnSpacing', 5,
		'columnAnchorPoint', "LEFT"
	)

		raid:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 40, -40)

	for i = 1,MAX_BOSS_FRAMES do
		local t_boss = _G["Boss"..i.."TargetFrame"]
		t_boss:UnregisterAllEvents()
		t_boss.Show = dummy
		t_boss:Hide()
		_G["Boss"..i.."TargetFrame".."HealthBar"]:UnregisterAllEvents()
		_G["Boss"..i.."TargetFrame".."ManaBar"]:UnregisterAllEvents()
	end

	local boss = {}
	for i = 1, MAX_BOSS_FRAMES do
		boss[i] = self:Spawn("boss"..i, "oUF_KamiiBoss"..i)
		if i == 1 then
			boss[i]:SetPoint("LEFT", UIParent, "LEFT", 75, 0)
		else
			boss[i]:SetPoint("TOPLEFT", boss[i-1], "BOTTOMLEFT", 0, -40)
		end
	end
end)

--[[ Targettarget text ]]

local tt = CreateFrame("Frame", nil, UIParent)
tt:SetPoint("CENTER", UIParent, "CENTER", 49, -209)
tt:SetWidth(110)
tt:SetHeight(12)

ttt = CreatePFS(tt, 10, "RIGHT")
ttt:SetAllPoints(tt)

tt:SetScript("OnUpdate", function()
		ttt:SetText(UnitName"targettarget")
		--ttt:SetTextColor(1, 1, 1)
end)